<script>

  import { beforeUpdate, onMount, onDestroy } from 'svelte';

  export let setApp   = null;
  export let number   = '';
  export let contacts = [];

  export let target = null;

  let contactLabel = null;
  let timeInterval = null;
  let start        = Math.floor(new Date / 1000);
  
  let _time = '00:00';

  function endCall() {
    window.parent.postMessage(JSON.stringify({action: 'end_call', number, target}));
    setApp(null);
  }

  beforeUpdate(() => {

    const contact = contacts.find(e => e.number === target);

    if(contact)
      contactLabel = contact.name;
    else
      contactLabel = '#' + target;

  });

  onMount(() => {

    timeInterval = setInterval(() => {

      const now      = Math.floor(new Date / 1000);
      const duration = now - start;
      const minutes  = Math.floor(duration / 60);
      const seconds  = duration - minutes * 60;

      _time = `${minutes.toString().padStart(2, '0')}:${seconds.toString().padStart(2, '0')}`;

    }, 1000);

  });

  onDestroy(() => {
    clearInterval(timeInterval);
  })

</script>

<style>

  .app-incomingcall {
    width: calc(100% - 16px);
    height: 100%;
    user-select: none;
  }

  .contact-label {
    position: absolute;
    left: 50%;
    top: 20%;
    transform: translate(-50%, -50%);
    font-weight: bold;
    font-size: 2em;
    color: #FFF;
  }

  .time {
    position: absolute;
    top: 50%;
    margin-left: 50%;
    transform: translate(-50%, -50%) scale(0.75);
    font-size: 2em;
  }

  .call-button {
    position: absolute;
    left: 50%;
    top: 80%;
    transform: translate(-50%, -50%);
    width: 56px;
    height: 56px;
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: center;
    color: #FFF;
    border-radius: 50%;
  }

  .call-button:hover {
    border: 2px solid #FFF;
  }

  .end-call {
    background-color: #a92c2c;
    left: 50%;
    transform: translate(-50%, -50%);
  }

  @keyframes circle-light-1 {
    0%   { color: #B4CEFF; font-size: 1em}
    25%  { color: #FFFFFF; font-size: 1.25em}
    50%  { color: #005AFF; font-size: 1.5em}
    75%  { color: #3079FF; font-size: 1.75em}
    100% { color: #6A9FFF; font-size: 2em}
  }

  @keyframes circle-light-reverse-1 {
    0%   { color: #6A9FFF; font-size: 2em}
    25%  { color: #3079FF; font-size: 1.75em}
    50%  { color: #005AFF; font-size: 1.5em}
    75%  { color: #FFFFFF; font-size: 1.25em}
    100% { color: #B4CEFF; font-size: 1em}
  }

  @keyframes circle-light-2 {
    0%   { color: #3079FF; font-size: 1.75em}
    25%  { color: #6A9FFF; font-size: 2em}
    50%  { color: #B4CEFF; font-size: 1em}
    75%  { color: #FFFFFF; font-size: 1.25em}
    100% { color: #005AFF; font-size: 1.5em}
  }

  @keyframes circle-light-reverse-2 {
    0%   { color: #005AFF; font-size: 1.5em}
    25%  { color: #FFFFFF; font-size: 1.25em}
    50%  { color: #B4CEFF; font-size: 1em}
    75%  { color: #6A9FFF; font-size: 2em}
    100% { color: #3079FF; font-size: 1.75em}
  }

  @keyframes circle-light-3 {
    0%   { color: #005AFF; font-size: 1.5em}
    25%  { color: #3079FF; font-size: 1.75em}
    50%  { color: #6A9FFF; font-size: 2em}
    75%  { color: #B4CEFF; font-size: 1em}
    100% { color: #FFFFFF; font-size: 1.25em}
  }

  @keyframes circle-light-reverse-3 {
    0%   { color: #FFFFFF; font-size: 1.25em}
    25%  { color: #B4CEFF; font-size: 1.1em}
    50%  { color: #6A9FFF; font-size: 2em}
    75%  { color: #3079FF; font-size: 1.75em}
    100% { color: #005AFF; font-size: 1.5em}
  }

</style>

<div class="app-incomingcall">

  <div class="time">
    {_time}
  </div>

  <div class="contact-label">{contactLabel}</div>

  <div class="call-button end-call" on:mouseup={e => endCall()}>
    <i class="fas fa-phone-slash fa-2x"></i>
  </div>

</div>